// Generated for Chilkat v10.0.0
//using System;
//using System.Collections.Generic;
//using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CodeSign : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_Create2W", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkCodeSignU_Create2W(int bCallbackOwned);

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setupReturnedObjCb", CharSet = CharSet.Unicode)]
		private static extern void CkCodeSignU_setupReturnedObjCb(System.IntPtr pObj);

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkCodeSignU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_getHeartbeatMsW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_getHeartbeatMsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_putHeartbeatMsW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_putHeartbeatMsW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_uncommonOptionsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_uncommonOptionsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_putUncommonOptionsW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_putUncommonOptionsW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_AddSignatureW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_AddSignatureW(System.IntPtr pObj, string path, System.IntPtr cert, System.IntPtr options);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_AddSignatureAsyncW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCodeSignU_AddSignatureAsyncW(System.IntPtr pObj, string path, System.IntPtr cert, System.IntPtr options);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_RemoveSignatureW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_RemoveSignatureW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_VerifySignatureW", CharSet = CharSet.Unicode)]
        private static extern int CkCodeSignU_VerifySignatureW(System.IntPtr pObj, string path, System.IntPtr sigInfo);


		public CodeSign()
		{
			m_pObj = CkCodeSignU_Create2W(1);
			m_needDisposal = true;
		}

		public CodeSign(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
			CkCodeSignU_setupReturnedObjCb(m_pObj);
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkCodeSignU_DisposeW(p);
			}
		}

		~CodeSign()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

        public delegate void AbortCheck([MarshalAs(UnmanagedType.Bool)] out bool abort);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setFnAbortCheckW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_setFnAbortCheckW(System.IntPtr pObj, AbortCheck delegateFn);
	
        public void setAbortCheckCb(AbortCheck callbackObj)
        {
            CkCodeSignU_setFnAbortCheckW(m_pObj, callbackObj);
        }

        public delegate void PercentDone([MarshalAs(UnmanagedType.I4)]int pctDone, [MarshalAs(UnmanagedType.Bool)] out bool abort);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setFnPercentDoneW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_setFnPercentDoneW(System.IntPtr pObj, PercentDone delegateFn);
	
        public void setPercentDoneCb(PercentDone callbackObj)
        {
            CkCodeSignU_setFnPercentDoneW(m_pObj, callbackObj);
        }

        public delegate void ProgressInfo([MarshalAs(UnmanagedType.LPWStr)]string name, [MarshalAs(UnmanagedType.LPWStr)]string value);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setFnProgressInfoW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_setFnProgressInfoW(System.IntPtr pObj, ProgressInfo delegateFn);
	
        public void setProgressInfoCb(ProgressInfo callbackObj)
        {
            CkCodeSignU_setFnProgressInfoW(m_pObj, callbackObj);
        }

        public delegate void TaskIdCompleted(int taskId);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setFnTaskIdCompletedW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_setFnTaskIdCompletedW(System.IntPtr pObj, TaskIdCompleted delegateFn);
	
        public void setTaskIdCompletedCb(TaskIdCompleted callbackObj)
        {
            CkCodeSignU_setFnTaskIdCompletedW(m_pObj, callbackObj);
        }

        public delegate void TextData([MarshalAs(UnmanagedType.LPWStr)]string data);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCodeSignU_setFnTextDataW", CharSet = CharSet.Unicode)]
        private static extern void CkCodeSignU_setFnTextDataW(System.IntPtr pObj, TextData delegateFn);
	
        public void setTextDataCb(TextData callbackObj)
        {
            CkCodeSignU_setFnTextDataW(m_pObj, callbackObj);
        }

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkCodeSignU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkCodeSignU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// This property is only valid in programming environment and languages that allow
	/// for event callbacks.
	/// 
	/// Specifies the time interval in milliseconds between AbortCheck events. A value
	/// of 0 (the default) indicate that no AbortCheck events will fire. Any HTTP
	/// operation can be aborted via the AbortCheck event.
	/// 
	///
	/// </summary>
	public int HeartbeatMs
	{
		get
		{
			return CkCodeSignU_getHeartbeatMsW(m_pObj);
		}
		set
		{
			CkCodeSignU_putHeartbeatMsW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkCodeSignU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkCodeSignU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkCodeSignU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkCodeSignU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCodeSignU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// This is a catch-all property to be used for uncommon needs. This property
	/// defaults to the empty string and should typically remain empty.
	/// 
	/// Can be set to a list of the following comma separated keywords:
	///     "codesign-allow-expired-cert" - Don't fail authenticode signature validation
	///     because the signing certificate is expired.
	/// 
	///
	/// </summary>
	public string UncommonOptions
	{
		get
		{
			return ckFromUni(CkCodeSignU_uncommonOptionsW(m_pObj));
		}
		set
		{
			CkCodeSignU_putUncommonOptionsW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkCodeSignU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCodeSignU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.94"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkCodeSignU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Authenticode signs a DLL or EXE.
	/// </summary>
	public bool AddSignature(string path, Cert cert, JsonObject options)
	{
		int result = CkCodeSignU_AddSignatureW(m_pObj, path, cert == null ? System.IntPtr.Zero : cert.getImpl(), options == null ? System.IntPtr.Zero : options.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Creates an asynchronous task to call the AddSignature method with the arguments
	/// provided. (Async methods are available starting in Chilkat v9.5.0.52.)
	/// </summary>
	public Task AddSignatureAsync(string path, Cert cert, JsonObject options)
	{
		System.IntPtr result = CkCodeSignU_AddSignatureAsyncW(m_pObj, path, cert == null ? System.IntPtr.Zero : cert.getImpl(), options == null ? System.IntPtr.Zero : options.getImpl());
		if (result == System.IntPtr.Zero) return null;
		return new Task(result);
	}
	/// <summary>
	/// Removes the authenticode signature of a Windows executable or DLL. The path to
	/// the executable/DLL is passed in path.
	/// </summary>
	public bool RemoveSignature(string path)
	{
		int result = CkCodeSignU_RemoveSignatureW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkCodeSignU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies the signature of a Windows executable or DLL. The path to the
	/// executable/DLL is passed in path. Information about the signature is returned in
	/// sigInfo. Returns true if the signature is verified indicating the EXE or DLL can
	/// be trusted. Otherwise returns false.
	/// </summary>
	public bool VerifySignature(string path, JsonObject sigInfo)
	{
		int result = CkCodeSignU_VerifySignatureW(m_pObj, path, sigInfo == null ? System.IntPtr.Zero : sigInfo.getImpl());
		return result == 0 ? false : true;
	}


	}
}

